/////////////////////////////////////////////////////////////////
//Beispiel aus Kapitel Bibliothken: Minim
//Die 1024 Werte des Zeit-Amplitude-Puffers werden bei jedem draw()
//Takt einzeln fortschreitend für linken und rechten Kanal und für Mix
//ausgelesen. Damit wird die Farbe festgelegt. Zusätzlich wird die aktuelle 
//Durchschnitts-Amplitude des gesamten Puffers festgestellt. Mit
//diesem Wert wird die Form des zu zeichnenden Objekt bestimmt. 
//Die Umrechnungen für Farbe und Form sind nicht zwingend. Hier lohnt
//es sich zu experimentieren. 
/////////////////////////////////////////////////////////////////////

import ddf.minim.*;   

Minim minim;                              
AudioPlayer musik;   
int breite = 1064;//1064-2*rand: Ein Puffer-Speicherinhalt
int hoehe = 800;
int zAbstand = 20;  //Zeilenabstand
int rand = zAbstand;  // Randbreite
int aFaktor = 20;   // Amplituden-Faktor
int y = zAbstand;
int k = 0;//Pixelnummer 
int n = 0;//Nummer Pixel in einer Zeile
//effektive Anzahl zu beschreibender Pixel:
int ePixelAnzahl = int((breite-2*rand)*(hoehe-2*rand)/zAbstand);  //hier 39526              
float zeilenNummer;  
float aMix,aLinks,aRechts; //Sample-Werte
float amplitude; //Durchschnitts-Amplitude des gesamten Puffers
float radius; //Für zu zeichnende Ellipsen
float rot, gruen,blau; 
float transparenz ;
float weight ; 
float delta;
int eckenAnzahl;
float winkel;

void setup() {
  surface.setSize(breite,hoehe);                       
  background(255);                       
  minim = new Minim(this);               
  musik = minim.loadFile ("musik.mp3");
  musik.play();                           
}

void draw() {
  //Durchzählen aller zum Zeichnen verwendbarer Pixel von 0 bis PixelAnzahl:
  k = int(map(musik.position(), 0, musik.length(), 0, ePixelAnzahl));
  zeilenNummer = k/(breite-2*rand);// aktuelle zeilenNummer
  n = k- int((breite-2*rand)*zeilenNummer); 
  aMix = musik.mix.get(int(n));
  aLinks = musik.left.get(int(n)); 
  aRechts = musik.right.get(int(n));
  amplitude = musik.mix.level();
  radius = aMix*aMix * zAbstand * aFaktor; 
  if(radius > 14) radius = 14; 
  if(radius <  5) radius =  5; 
  rot = aLinks*aLinks*30000 % 256;
  gruen = aMix*aMix*30000 % 256;
  blau = aRechts*aRechts*30000 % 256;
  transparenz = amplitude*1200 % 200; 
  weight = amplitude*amplitude*1000 % 7;             
  delta = 150*aMix*aMix*zAbstand; 
  if(delta > 8) delta =8; 
  if(delta < 2) delta =2; 
  zeileZeichnen(int(zeilenNummer));
  
 
}

void zeileZeichnen(int zeilenNummer){
   this.zeilenNummer = zeilenNummer;
   
    //senkrechte Striche zeichnen
  if(weight < 2.0){
    stroke(rot, gruen, blau, transparenz*4); 
    strokeWeight(weight+0.5);
    line(n+rand, y*zeilenNummer+rand+delta, n+rand, y*zeilenNummer+rand-delta);
  }
  
  //Ellipsen zeichnen
  if(weight >= 2.0 && weight <2.8){
    strokeWeight(1);
    fill(rot,gruen,blau,transparenz*0.5);
    ellipse(n+rand,y*zeilenNummer+rand,weight*random(5,12),weight*random(4,10));
  }
  
  //Polygone zeichnen
  if(weight >=2.8){
    if(radius > 8){
      strokeWeight(1);
      stroke(rot, gruen, blau, transparenz*4);
    }else{noStroke();}
    fill(rot, gruen, blau, transparenz);
    pushMatrix();
    translate(n+rand, y*zeilenNummer+rand);
    eckenAnzahl = int(amplitude*amplitude*1000);
    if(eckenAnzahl > 8) eckenAnzahl = 8;
    if(eckenAnzahl < 3) eckenAnzahl =3;
    winkel = TWO_PI/eckenAnzahl; println(eckenAnzahl);
    beginShape();
      for (int i=0; i<=eckenAnzahl; i++) {
        float xV = 0 + cos(winkel*i) * radius;
        float yV = 0 + sin(winkel*i) * radius;
        vertex(xV, yV);
   }
   endShape();
   popMatrix();   
  } 
}


void keyPressed(){ 
  if (key == 's'){
    saveFrame("musikBild.jpg");
  }
  
  if(key == 'h'){
    stop();
  }
}
void stop() {
  musik.close();
  minim.stop();
  super.stop();
}